/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.Map;

import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.Pendidikan;
import com.portofolio.entity.vo.PendidikanId;

@Lazy
@Repository("pendidikanDao")
public interface PendidikanDao extends CrudRepository<Pendidikan, PendidikanId> {
    

    @Query(QListAll)
    Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,@Param("statusEnabled") boolean statusEnabled, Pageable page);
    
    @Query(QListAll + " and model.namaPendidikan like %:namaPendidikan% ")
    Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, @Param("namaPendidikan") String namaPendidikan, @Param("statusEnabled") boolean statusEnabled,Pageable page);
    
    @Query(QListAll + " and model.id.kdPendidikan = :kdPendidikan")
    Map<String, Object> findByKdPendidikan(@Param("kdProfile") Integer kdProfile, @Param("kdPendidikan") String kdPendidikan,@Param("statusEnabled") boolean statusEnabled);
       
    
    String QListAll ="select new map(model.id.kdPendidikan as kdPendidikan,model.id.kdProfile as kdProfile "
            + ", model.namaPendidikan as namaPendidikan " 
            + ", model.reportDisplay as reportDisplay " 
            + ", model.noUrut as noUrut " 
            + ", model.kdPendidikanHead as kdPendidikanHead "
            + ", pendidikanHead.namaPendidikan as namaPendidikanHead" 
            + ", model.kodeExternal as kodeExternal " 
            + ", model.namaExternal as namaExternal " 
            + ", model.statusEnabled as statusEnabled " 
            + ", model.noRec as noRec, model.version as version )" 
            + " from Pendidikan model left join model.id id "
            + "left join model.pendidikanHead pendidikanHead "
            + "where id.kdProfile=:kdProfile and model.statusEnabled=:statusEnabled ";
  
	    
}
